#ifndef _gshsmap_
#define _gshsmap_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef M_PI
#define M_PI          3.14159265358979323846
#endif

typedef struct gshhs_hdr_ {	/* Global Self-consistant Hierarchical High-resolution Shorelines Header */
	int id;				/* Unique polygon id number, starting at 0 */
	int n;				/* Number of points in this polygon */
	int level;			/* 1 land, 2 lake, 3 island_in_lake, 4 pond_in_island_in_lake */
	int west, east, south, north;	/* min/max extent in micro-degrees */
	int area;			/* Area of polygon in 1/10 km^2 */
	short int greenwich;		/* Greenwich is 1 if Greenwich is crossed */
	short int source;		/* 0 = CIA WDBII, 1 = WVS */

	int version;
	int area_full;
	int container;
	int ancestor;
} GSHHSHdr;


#ifdef  __cplusplus
extern "C" {
#endif

extern int gshhs_unstuff_hdr (GSHHSHdr **gshhs, char **stream);
extern int gshhs_skip_pts (GSHHSHdr *gshhs, char **stream);
extern int gshhsmap_open (void **handle);
extern int gshhsmap_reset (void *handle);
extern int gshhsmap_select (void *handle, char *types, char *resolution, double bb_lonwest, double bb_loneast,
				double bb_latsouth, double bb_latnorth, double bb_lonref, double bb_latref);
extern int gshhsmap_nextseg (void *handle, int *npts, int *npts_size, float **lon, float **lat, 
				char *type, int *level, int *antipode);
extern int gshhsmap_inside_eo (float lontest, float lattest, int npts, float *lon, float *lat);

#ifdef  __cplusplus
}
#endif

#endif
