
#ifndef _p_eval_
#define _p_eval_ 

typedef struct Function { 
    char *name ; 
    int type ; 
    int argtype ; 
    int kind ; 
    int lextype ; 
    double (*dblf)() ; 
    long   (*intf)() ; 
    char * (*strf)() ;
    } Function ;

extern Function DSFunctions[] ;
extern int DSnfunctions ; 

extern Dbptr Db_eval ; 

/* operator may be one of the following: */
#define OR  	0
#define AND 	1
#define LT	2
#define LE	3
#define EQ	4
#define GE	5
#define GT	6
#define NE	7

#define PLUS    8
#define MINUS   9
#define TIMES  10
#define DIVIDE 11

#define LIKE 12
#define UNLIKE 13

#define POW 14
#define QUESTION 15
#define ASSIGN 16

#define CONCAT 17
#define NEGATE 18
#define MODULUS 19

#define BITOR  20
#define BITAND 21
#define BITRIGHT 22
#define BITLEFT  23


/* result type may be one of the following 
  (in addition to the standard db types */
#define INVALID 0
#define REGEXP  7

#define NTYPES 8

/* kind may be one of the following */
#define IMMEDIATE 101
#define OPERATOR  102
#define FIELD  103
#define FUNCT1 104
#define TOTYPE  105
#define FUNCT2 106
#define FUNCT3 107
#define FUNCT4 108
#define NULLFIELD 109
#define FPATSUB 110
#define FUNCT0 111
#define DBFUNCT0 112
#define DBFUNCT1 113
#define DBFUNCT2 114
#define DBFUNCT3 115
#define DBFUNCT4 116
#define EXEC 117
#define PIPE 118
#define	DBEVAL1 119
#define OVERLOAD 120

#endif 

/* $Id$ */
