#ifndef _sort_
#define _sort_

#include <time.h>

typedef struct Dbkey_component {
    long id ; 		/* field id if plain field, otherwise -1 */
    long type ;		/* type of this (simple) field */
    long disp ;		/* displacement for this component in key */
    long size ; 		/* maximum length of string field */
    Expression *expr ; 	/* compiled expression if not plain field */
    long range_end ; 	/* flag for end of range (to fill in envelope value) */
} Dbkey_component ;

typedef struct Dbkey_element { 
    long type ; 		/* type of this key element -- may be a range */
    long disp ; 		/* displacement for values for this element in a key */
    long size ;		/* size of a component of this element (for strings) */
} Dbkey_element ;

typedef struct Dbjig { 
    Dbptr db ; 
    Tbl 	*pattern ; 
    Tbl		*key_component ; 
    Tbl		*key_element ;
    long		size ;
    long		range ;
} Dbjig ; 

typedef struct Dbindex { 
    Dbjig       *search_jig ;
    Dbjig       *index_jig ;
    Tbl 	*index ; 
    long	nold ;
    int		unique, monotonic ;
    time_t        last_update ;
    char       *name, *path ;
} Dbindex ; 


#define dbREAL_RANGE -999
#define dbINTEGER_RANGE -998
#define dbOFFDATE -357
#define dbENVELOPE_DOUBLE -358
#define dbENVELOPE_INTEGER -359

extern char *dbkey ( Dbindex * dbindex, long j );

#endif

/* $Id$ */
